#include "compito.h"

Palazzo::Palazzo(int N){
  maxPiani = (N<=0)? 1: N;
  v = new stato* [maxPiani];
  for(int i=0; i< maxPiani; i++) {
    v[i] = new stato[i+1];
    for (int j = 0; j <= i; j++)
      v[i][j]= Chiusa;
  }
  quantiPiani = 1;
}

Palazzo::Palazzo(const Palazzo& p){
  maxPiani = p.maxPiani;
  quantiPiani = p.quantiPiani;
  v = new stato* [maxPiani];
  for(int i=0; i< maxPiani; i++) {
    v[i] = new stato[i+1];
    for (int j = 0; j <= i; j++)
      v[i][j]= p.v[i][j];
  }
}


bool Palazzo::aggiungi(){
  if (quantiPiani < maxPiani){
    quantiPiani++;    
    return true;
  }
  return false;
}

void Palazzo::cambia(int i, int j){
  if ((i<=0) || (j<=0) || (i > quantiPiani) || (j > i))
    return;
  if (v[i-1][j-1] == Chiusa)
    v[i-1][j-1] = Aperta;
  else
    v[i-1][j-1] = Chiusa;
}

Palazzo& Palazzo::operator%=(const Palazzo& p){
  if(quantiPiani != p.quantiPiani)
    return *this;
  for(int i=0; i< quantiPiani; i++)
    for (int j = 0; j <= i; j++)
      if (p.v[i][j] == Chiusa) v[i][j]=Chiusa;
        return *this;
}

int Palazzo::operator!() const{
  int conta=0;
  for(int i=0; i< quantiPiani; i++)
    for (int j = 0; j <= i; j++)
      if (v[i][j] == Aperta) conta++;
   return conta;
}

Palazzo::~Palazzo(){
  for(int i=0; i< maxPiani; i++)
    delete[]v[i];
  delete[]v;
}

ostream& operator<<(ostream& os, const Palazzo& p){
  cout << '<' << p.quantiPiani << '>' << endl;
  for(int i=0; i< p.quantiPiani; i++) {
    os << "Piano " << (i+1) << ": ";
    for (int j = 0; j <= i; j++)
      if (p.v[i][j]== Chiusa)
        os << "Chiusa" << ' ';
      else os << "Aperta" << ' ';
        os << endl;
  }
  return os;
}